# ----------------------------------------------------------------------------
# - whhdb-verifier                                                           -
# - wild cruncher:hierarchy verifier                    core / hardware / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whhdb_verifier
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher hierarchy verifier

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""
from wcr_core.db.whdb_verifier import WhdbVerifierModuleP, \
    WhdbHierarchyVerifier


#: List of all hierarchy verification modules to be enabled by default
WHHDB_VRFYM = []

class WhhdbHierarchyVerifier(WhdbHierarchyVerifier):
    """
    Message hierarchy verifier.
    """

    def __init__(self, modules=None):
        """
        :param modules: Additional verification modules to use.
        :type modules: Iterable[WhdbVerifierModuleP] | None
        """
        if modules:
            mods = list(WHHDB_VRFYM)
            mods.extend(modules)
        else:
            mods = WHHDB_VRFYM

        super().__init__(mods)
