# ----------------------------------------------------------------------------
# - wmehdb-meta-provider                                                     -
# - wild cruncher: meta-data provider                    core / message / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmhdb_meta_provider
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan hierarchy meta-data provider

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.db.whdb_meta_provider import WhdbMetaProvider
from wcr_core.modules.message.db.wmehdb_wgtbxmessage_instance import \
    WmehdbWightBoxMessageInstance
from wcr_core.db.whdb_instance import WhdbOperatorInstance
from wcr_core.modules.message.db.wmehdb_standard_operators import \
    WMEHDB_WBMESSAGE_CODE
from wcr_core.modules.message.db.wmehdb_block import WmehdbBlock

WMEHDB_STD_OPERINST_META = {WMEHDB_WBMESSAGE_CODE:
                                WmehdbWightBoxMessageInstance.META
                            }


class WmehdbMetaProvider(WhdbMetaProvider):
    def __init__(self, blockMetas):
        super().__init__()
        self.__blockMetas = blockMetas

    def getBlockMeta(self, btyp=None):
        if btyp:
            meta = self.__blockMetas.get(btyp)
            if meta:
                return meta
        return WmehdbBlock.META


    def getOperatorInstanceMeta(self, oper=None):
        opMeta = WMEHDB_STD_OPERINST_META.get(oper)
        return opMeta if opMeta is not None else WhdbOperatorInstance.META