# ----------------------------------------------------------------------------
# - wmplg-core-install-context                                               -
# - wild cruncher: core install context                core / model / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmplg_core_install_context
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Core install context

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.modules.model.plugin.wmplg_library_reader import \
    wmplg_read_operator
from wcr_core.plugin.wplg_core_install_context import \
    WplgCoreModuleInstallContext, WplgCoreModuleInstallContextP
from wcr_core.plugin.wplg_core_install_context_factory import \
    WplgCoreInstallContextFactoryMixin
from wcr_core.plugin.wplg_install_context_factory_api import \
    WplgModuleInstallContextFactoryP


# noinspection PyAbstractClass
class WmplgCoreModuleInstallContextP(WplgCoreModuleInstallContextP):
    pass


class WmplgCoreModuleInstallContext(WplgCoreModuleInstallContext,
                                    WmplgCoreModuleInstallContextP):
    """
    Model core install context.
    """
    def __init__(self, plgCode, plgName, plgDesc, module):
        """
        :param module: Model application module
        :type module: WmmodModelApplicationModuleMP
        """
        super().__init__(plgCode, plgName, plgDesc, module)

    def installOperatorFile(self, file, libCode=None):
        operator = wmplg_read_operator(file, libCode)
        self.installOperator(operator)


class WmpglCoreModuleInstallContextFactory(
        WplgModuleInstallContextFactoryP,
        WplgCoreInstallContextFactoryMixin):
    def __init__(self, module):
        """
        :param module: Model application module
        :type module: WmmodModelApplicationModuleMP
        """
        self.__module = module

    def getModuleCode(self):
        return self.__module.code

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WmplgCoreModuleInstallContext(
            plgCode, plgName, plgDesc, self.__module)
