# ----------------------------------------------------------------------------
# - wcact-action-base                                                        -
# - wild cruncher: action base class                core / sys_map / actions -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wcact_action_base
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Action base class

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_core.action.wact_action import WactActionBase


#: Action flag indicating potential database changes on execution
WCACT_ACTION_LOAD_HARD = 'loading_hard'
WCACT_ACTION_UP_HARD = 'update_hard'
WCACT_ACTION_LOAD_LOGIC = 'loading_logic'
WCACT_ACTION_UP_LOGIC = 'update_logic'
WCACT_ACTION_IMPORT_ROUTE = 'import_route_binding'



# noinspection PyAbstractClass
class WcactActionBase(WactActionBase):
    def __init__(self, name, description, *parameters):
        """
        :param name: Action name
        :type name: str
        :param description: Action description
        :type description: str
        :param parameters: Action parameter descriptions
        :type parameters: list[WactActionParameterP]
        """
        super().__init__(name, description, *parameters)

    def isEnabled(self, actx):
        """
        :type actx: WactActionExecutionContextP
        """
        if not super().isEnabled(actx):
            return False
        pctx = actx.getProjectContext()
        return bool(pctx) and pctx.getModule().code == 'System_Mapper'
