# ----------------------------------------------------------------------------
# - wvhdb-meta-provider                                                      -
# - wild cruncher: meta-data provider                      core / vlink / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wvhdb_meta_provider
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan hierarchy meta-data provider

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.db.whdb_meta_provider import WhdbMetaProvider
from wcr_core.modules.vlink.db.wvhdb_standard_operators import \
    WVHDB_VLINK_CODE
from wcr_core.modules.vlink.db.wvhdb_Vlink_instance import WvhdbVLinkInstance

WVHDB_STD_OPERINST_META = {WVHDB_VLINK_CODE:WvhdbVLinkInstance.META}

class WvhdbMetaProvider(WhdbMetaProvider):
    def __init__(self, blockMetas):
        super().__init__()

        self.__blockMetas = blockMetas

        self.__xpntMeta = {}

    def getBlockMeta(self, btyp=None):
        if btyp:
            meta = self.__blockMetas.get(btyp)
            if meta:
                return meta
        return WmhdbBlock.META

    def getOperatorInstanceMeta(self, oper=None):
        opMeta = WVHDB_STD_OPERINST_META.get(oper)
        return opMeta if opMeta is not None else WhdbOperatorInstance.META