# ----------------------------------------------------------------------------
# - wprj-project-info                                                        -
# - wild cruncher: wdb project meta information               core / project -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2013 clemens oertel                                   -
# - copyright (c) 2013-2013 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wprj_project_info
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher project meta information

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""


class WprjProjectInfo(object):
    """
    The WprjProjectInfo class is used to represent projects'
    meta-information.
    """

    def __init__(self):
        self.__projectName = ''
        self.__projectInfo = ''
        self.__company = ''
        self.__version = ''
        self.__author = ''

    @property
    def projectName(self):
        """
        Get the name of the associated project.

        :return: Project name
        :rtype: String
        """
        return self.__projectName

    @projectName.setter
    def projectName(self, projectName):
        """
        Set the name of the associated project.

        :param projectName: New name of the project
        :type projectName: String
        """
        self.__projectName = projectName

    @property
    def projectInfo(self):
        """
        Get the description for the associated project.

        :return: Project description
        :rtype: String
        """
        return self.__projectInfo

    @projectInfo.setter
    def projectInfo(self, projectInfo):
        """
        Set the description for the associated project.

        :param projectInfo: New description for the project
        :type projectInfo: String
        """
        self.__projectInfo = projectInfo

    @property
    def company(self):
        """
        Get the company info for the associated project.

        :return: Company
        :rtype: String
        """
        return self.__company

    @company.setter
    def company(self, company):
        """
        Set the company for the associated project.

        :param company: New company value for the project
        :type company: String
        """
        self.__company = company

    @property
    def version(self):
        """
        Get the version info for the associated project.

        :return: Version
        :rtype: String
        """
        return self.__version

    @version.setter
    def version(self, version):
        """
        Set the version for the associated project.

        :param version: New version value for the project
        :type version: String
        """
        self.__version = version

    @property
    def author(self):
        """
        Get the author info for the associated project.

        :return: Author
        :rtype: String
        """
        return self.__author

    @author.setter
    def author(self, author):
        """
        Set the author for the associated project.

        :param author: New author value for the project
        :type author: String
        """
        self.__author = author
