import re, os
from PyQt5.QtWidgets import QMessageBox
from silkan_common import __name__

WGUI_WINDOW_TITLE = __name__
__DEBUG__ = os.environ.get('WCR_DEBUG')

NameFormatMessageError = ('The name "{}" has an incorrect format: '
                          'names can only contain alphanumeric '
                          'or "_" characters')


class TestException(Exception):
    pass


def isNameValid(name):
    if name:
        if re.match("^[0-9A-Za-z_]+$", name) is None:
            return False
    return True


def showErrorWindow(windowTitle, errorMsg, *vars):
    if __DEBUG__ == 'True':
        raise TestException(errorMsg)
    else:
        msg = QMessageBox()
        msg.setIcon(QMessageBox.Information)
        msg.setText(errorMsg.format(*vars))
        msg.setWindowTitle(windowTitle)
        msg.exec_()
