# ----------------------------------------------------------------------------
# - wfgui-scene-view-mouse-handler                                           -
# - wild cruncher: mouse event handler         frontend / statemachine / gui -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wfgui_scene_view_mouse_handler
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - State machine mouse event handler

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.modules.statemachine.db.wfhdb_instance import \
    WfhdbXbtSourceProxyInstance, WfhdbXbtTargetProxyInstance
from wcr_frontend.gui.wgui_scene_view_mouse_handler import \
    WguiDefaultSceneViewMouseHandler
from wcr_frontend.modules.statemachine.gui.wfgui_xbt_utils import \
    wfgui_jump_to_sister_state


class WfguiSceneViewMouseHander(WguiDefaultSceneViewMouseHandler):
    def __init__(self, pctx, propDlgFy, scene, cntxtMenuFy):
        """
        :param pctx: Project context
        :type pctx: WfmodStatemachineProjectContextP
        :param propDlgFy: Property dialog factory
        :type propDlgFy: WguiPropertiesDialogFactoryP
        :param scene: Graphics scene
        :type scene: WguiGraphicsScene
        :param cntxtMenuFy: Context menu factory
        :type cntxtMenuFy: WguiContextMenuFactoryP
        """
        super().__init__(pctx, propDlgFy, scene, cntxtMenuFy)

        self.__scene = scene
        self.__projectCtx = pctx

    def _handleShiftDoubleClick(self, event, view, items):
        if items:
            item = items[0].topLevelItem()
            inst = item.getDataObject()

            if isinstance(inst, WfhdbXbtSourceProxyInstance) or \
                    isinstance(inst, WfhdbXbtTargetProxyInstance):
                wfgui_jump_to_sister_state(
                    inst, self.__projectCtx, self.__scene)
                return True

        return super()._handleShiftDoubleClick(event, view, items)
