# ----------------------------------------------------------------------------
# - wpgui-bus-instance-props-dialog                                          -
# - wild cruncher - system : bus instance properties dialog widgets          -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 samuel longchamps                                -
# - copyright (c) 2013-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wpgui_bus_instance_props_dialog
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher system bus instance properties dialog

.. moduleauthor:: Samuel Longchamps <samuel.longchamps@silkan.com>
"""
from wcr_frontend.gui.wgui_operator_instance_props_dialog import \
    WguiOperatorInstancePropertiesDialog
from wcr_frontend.gui.wgui_props_dialog_widget import WguiPropertiesWidgetP


class WpguiPhyBusInstancePropertiesDialog(
        WguiOperatorInstancePropertiesDialog):

    _TYPE_NAME = 'Physical Bus Instance'

    def __init__(self, inst, pctx, updateF, selectXpnt=None, parent=None):
        """
        :param inst: the function object
        :type inst: WhdbOperatorInstanceP
        :param pctx: Project context
        :type pctx: WsmodSimulationProjectContextP
        :param updateF: Callback function to notify about saves
        :type updateF: () -> _
        :param selectXpnt: Initially selected connection point, if any
        :type selectXpnt: WhdbConnectionPointP
        :param parent: Parent widget
        """
        super().__init__(inst, pctx, updateF, selectXpnt, parent)

    def _createAdditionalInstancePropertiesWidgets(self, inst, pctx):
        """
        :param inst: the instance object
        :type inst: WphdbPhyBusInstance
        :param pctx: Project context
        :type pctx: WpmodSystemProjectContextP
        :return: Additional instance properties widget as a list of widgets
        :rtype: list[WguiPropertiesWidgetP]
        """
        return []

    # noinspection PyMethodMayBeStatic
    def _createConnectionPointsPropertiesWidget(self, inst, pctx):
        """
        :param inst: the instance object
        :type inst: WphdbPhyBusInstance
        :param pctx: Project context
        :type pctx: WpmodSystemProjectContextP
        :return: Connection points properties tab description
        :rtype: (str, WguiPropertiesWidgetP) | None
        """
        return None
