import ctypes as ct
import time
import libpcap as pcap

######################################################################################
# script to read a pcap file and loop infinitly to send frames through an interface
######################################################################################

# name of the interface
DEVICE = b'\\Device\\NPF_{5ED8EECE-E052-4F7B-86D9-3DE2C525A151}'

# function that will open and send the frames
@pcap.pcap_handler
def packetHandler1G(device, pkthdr, packet):
    dataLength = 188
    handle = pcap.open_live(DEVICE, 10000, 1, 10000, ebuf)
    bytes_written = pcap.sendpacket(handle, packet, dataLength)
    print(bytes_written)


if __name__ == '__main__':
    ebuf = ct.create_string_buffer(pcap.PCAP_ERRBUF_SIZE)
    # infinite loop
    while 1:
        # read file
        pd = pcap.open_offline(ct.c_char_p(b'Deconnexion_Link.pcap'), ebuf)
        if not pd:
            print("{!s}", ebuf.value.decode("utf-8", "ignore"))
            exit()
        elif pcap.loop(pd, 0, packetHandler1G, None) < 0:
            print("pcap_loop() failed: ")
            exit()
        time.sleep(10)
