#ifndef __CETRACFONCTIONS_H__
#define __CETRACFONCTIONS_H__

#include <linux/pci.h>
#include <linux/interrupt.h>

#include "cetracTypes.h"
#include "cetracDriver.h"

#ifdef SILKAN_DEEP_DEBUG
void deverminage(echange_t *pDeverm, DEVICE_EXTENSION   *pDev);
#else
static inline void deverminage(echange_t *pDeverm, DEVICE_EXTENSION   *pDev) {}
#endif

struct cetrac_board *cetrac_board_alloc(struct device *dev, const struct file_operations *cetrac_fops);
int cetrac_board_register(struct cetrac_board *brd);
void cetrac_board_unregister(struct cetrac_board *brd);

/* fonctions appel�es a l'activation/d�sactivation du driver */
int     cetrac_pci_probe(struct pci_dev *p_dev,const struct pci_device_id *id);
void    cetrac_pci_remove(struct pci_dev *p_dev);

/* les file system operations */
int     cetrac_open(struct inode *inode, struct file  *filep);
int     cetrac_release(struct inode *inode, struct file *filep);
long    cetrac_ioctl(struct file *filep, unsigned int cmd,unsigned long arg);
int     cetrac_flush(struct file *filep,  fl_owner_t id);

/* le sous-prog d'interruption et la tasklet */
//ccur irqreturn_t cetrac_interrupt(int irq,void *data,struct pt_regs *regs);
irqreturn_t cetrac_interrupt(int irq,void *data);
void        tasklet_cetrac(unsigned long data);


#endif

static inline u32 cetrac_ctl_read32(DEVICE_EXTENSION *brd, int reg)
{
        return readl(brd->Control + reg);
}

static inline void cetrac_ctl_write32(DEVICE_EXTENSION *brd, int reg, u32 val)
{
	writel(val, brd->Control + reg);
}

static inline u32 cetrac_evt_read32(DEVICE_EXTENSION *brd, int reg)
{
        return readl(brd->Events + reg);
}

static inline void cetrac_evt_write32(DEVICE_EXTENSION *brd, int reg, u32 val)
{
	writel(val, brd->Events + reg);
}

