
#include "cetracLists.h"

void CetracFifoRemove(struct kfifo *fifo, cetracU32 Idt)
{
	int status, len, count;
	void *buf;
	EVENT *evt;

	len = kfifo_size(fifo);
	buf = kzalloc(len, GFP_ATOMIC);
	if (!buf) {
		pr_err("%s: allocation failed\n", __func__);
		return;
	}

	/* fill fifo buffer */
	count = kfifo_len(fifo);
	status = kfifo_out(fifo, buf, count);
	if (status != count) {
		pr_err("%s: failed to get data\n", __func__);
		kfree(buf);
		return;
	}

	/* fill fifo back, filtering events */
	kfifo_reset(fifo);
	for (evt = (EVENT *)buf; evt < (EVENT *)(buf+count); evt++) {
		if (evt->Type_Idt != Idt) {
			status = kfifo_in(fifo, evt, sizeof(EVENT));
			if (status != sizeof(EVENT)) {
				pr_err("%s: failed to copy event\n", __func__);
				break;
			}
		}
	}
	kfree(buf);
}

