/**
 * \file init.h
 * \brief Header file : functions which allows to initialize parameters of a Myddleware
 * \author HRakotomalala
 * \date 2018
 */

/* Functions */
/* mitracSetupInit */
/* mitracAppInit */
/* createLogFile */
/* bindFunc */
/* cCetracInit */
/* cetracStart */
/* initApp */
/* cetracCreateEventsList */
/* cetracWaitState */
/* cetracAddEventInList */

#ifndef INIT_H_
#define INIT_H_

#include "mitracAppApi.h"
#include "mitracSetupApi.h"
#include "cCetracAPI.h"
#include "mitracOptParse.h"
#include "inOutTable.h"
#include "cVistasPlusApi.h"
#include "monitoring.h"
#include "monitoringParameters.h"

// mitracSetupInit + mitracAppInit + createLogFile 
// cCetracInit
// initApp()
// cetracCreateEventsList + cetracWaitState + cetracAddEventInList
t_error doInit(void *libSetup, 
	       void *libApp,
	       FILE* file,
	       mitracOpt mitracOption,
	       cetracFd *pFd,
	       cetracEventsList cetracList,
	       unsigned int* cetracError,
	       unsigned int* errorCode);

//mitracSetupInit + mitracAppInit
t_error libInit(void *libSetup, 
		void *libApp,
		unsigned int* errorCode);

//cCetracInit
t_error cetracInitBuffer(unsigned int* errorCode);

#endif // INIT_H_
