/**
 * \file mitracAppApi.h
 * \brief Define the mitracAppApi, that can be populated using a .so file
 * \author PiV.
 */

#ifndef MITRAC_APP_API_H
#define MITRAC_APP_APIH

#include "mitracErrorCodes.h"

/// Define a type for the mitrac display error function
typedef void(*f_mic_disp)(t_error);
/// Define a type for the mitrac init function
typedef t_error(*f_mic_init)(const char*, unsigned int*);
/// Define a type for the mitrac read function
typedef t_error(*f_mic_read)(const char*, size_t, void*, unsigned int*);
/// Define a type for the mitrac write function
typedef t_error(*f_mic_write)(const char*, size_t, void*, unsigned int*);
/// Define a type for the mitrac reset function
typedef t_error(*f_mic_reset)(const char*, unsigned int*);

extern void (*bindFunc)(f_mic_disp dsp, f_mic_init ini, f_mic_read red, f_mic_write wrt,
                        f_mic_reset rst);
extern void (*initApp)(void);
extern void (*stepApp)(void);
extern void (*resetApp)(void);

t_error mitracAppOpen(void **libDesc, const char *fullLibName, unsigned int* errorCode);
t_error mitracAppInit(void *libDesc, unsigned int* errorCode);
t_error mitracAppClose(void *libDesc, unsigned int* errorCode);

#endif //MITRAC_APP_API_H_
