/**
 * \file mitracSetupApi.h
 * \brief Define the mitracSetupApi, that can be populated using a .so file
 * \author A. Maayay
 */

#ifndef MITRAC_SETUP_API_H_
#define MITRAC_SETUP_API_H_

#include "inOutTable.h"
#include "mitracErrorCodes.h"

extern int nbBufferIn;
extern int nbBufferOut;
extern int nbBufferSystem;

extern inOutTableStrct*    tableIn;
extern inOutTableStrct*    tableOut;
extern inOutTableStrct*    tableSys;

extern timerStrct timerCetrac;

t_error mitracSetupOpen(void **libDesc, const char *fullLibName, unsigned int* errorCode);
t_error mitracSetupInit(void *libDesc, unsigned int* errorCode);
t_error mitracSetupClose(void *libDesc, unsigned int* errorCode);

#endif //MITRAC_SETUP_API_H_

