// ------------------------------------------------------------------------------------------------
/// file monitoring.h
/// @author HRakotomalala
/// @date 2018
/// @brief Allow to spy trafic in a cetrac, functions are used in mitrac application
// ------------------------------------------------------------------------------------------------
// -Cetrac Monitor Project                                                                -
// -copyright (c) 2018 Silkan                                                               -
// ------------------------------------------------------------------------------------------------

#include "inOutTable.h"

#ifndef SPYAPP_H
#define SPYAPP_H

//Fonctions GET PAYLOAD

/// @brief Create a file which contains all data
/// @return the log file
/// @param[in]	nameFile chosen name of the log file
FILE* createLogFile(char* nameFile);

/// @brief Insert local time into a file
/// @return the log file
/// @param[in]	file log file 
void insertTime(FILE* file);

/// @brief Allow to retrieve a data from a table
/// @return a data buffer printed into a log file with all corresponding data
/// @param[out]	log_file	file where data will be printed
/// @param[in]	table		dynamic input or output structure table
/// @param[in]	index 		element of the structure table
/// @param[in]	typeOfData	raw or process Data : 0 for raw, 1 for process and 2 for both 
/// @param[in]	dataInOut	indicates if data are input or output
/// @param[in]	activeTime	activation of time stamping
void getData(FILE* log_file, inOutTableStrct* table, unsigned int index, unsigned char typeOfData, unsigned char dataInOut, unsigned char activeTime);

#endif
