/**
 * \file reset.h
 * \brief Header file : functions which allows to reset parameters of a Myddleware
 * \author HRakotomalala
 * \date 2018
 */

/* Functions : */
/* cetracStop */
/* cCetracReset */
/* resetApp */
/* cetracDeleteEventsList */
/* fclose(LogFile) */

#ifndef RESET_H_
#define RESET_H_

//header to add
#include "inOutTable.h"
#include "cCetracAPI.h"
#include "mitracErrorCodes.h"
#include "mitracOptParse.h"
#include "monitoring.h"
#include "monitoringParameters.h"
#include "mitracAppApi.h"

// doReset : resetApp + cCetracReset + deleteListEvent + close(LogFile)
t_error doReset(cetracFd Fd,
		cetracEventsList cetracList,
		FILE* file,
		mitracOpt mitracOption,
		unsigned int* cetracError,
		unsigned int* errorCode);

//cCetracReset
t_error cetracResetBuffer(unsigned int* errorCode);

//cetracDeleteEventsList
t_error removeCetracList(mitracOpt mitracOption,
			cetracFd Fd,
			cetracEventsList cetracList,
			unsigned int* cetracError);

//fclose
t_error closeFile(FILE* file,
		  mitracOpt mitracOption,
		  unsigned int* errorCode);

#endif // RESET_H_
